/*
 * WebApiSegura Token JWT XrmAPI
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client;

import java.util.Map;
import java.util.List;


public class ApiException extends Exception {
    private final int code;
    private final Map<String, List<String>> responseHeaders ;
    private final String responseBody ;

    public ApiException() {
		
        this.responseHeaders = null;
		this.code = 0;
		this.responseBody = "";
	}

    public ApiException(Throwable throwable) {
        super(throwable);
		this.code = 0;
		this.responseHeaders = null;
        this.responseBody = "";
    }

    public ApiException(String message) {
        super(message);
		this.code = 0;
		this.responseHeaders = null;
        this.responseBody = "";
    }

    public ApiException(String message, Throwable throwable, int code, Map<String, List<String>> responseHeaders, String responseBody) {
        super(message, throwable);
        this.code = code;
        this.responseHeaders = responseHeaders;
        this.responseBody = responseBody;
    }

    public ApiException(String message, int code, Map<String, List<String>> responseHeaders, String responseBody) {
        this(message, (Throwable) null, code, responseHeaders, responseBody);
    }

    public ApiException(String message, Throwable throwable, int code, Map<String, List<String>> responseHeaders) {
        this(message, throwable, code, responseHeaders, null);
    }

    public ApiException(int code, Map<String, List<String>> responseHeaders, String responseBody) {
        this((String) null, (Throwable) null, code, responseHeaders, responseBody);
    }

    public ApiException(int code, String message) {
        super(message);
        this.code = code;
		this.responseHeaders = null;
        this.responseBody = "";

    }

    public ApiException(int code, String message, Map<String, List<String>> responseHeaders, String responseBody) {
       
		this.code=code;
        this.responseHeaders = responseHeaders;
        this.responseBody = message + responseBody;
    }

    /**
     * Get the HTTP status code.
     *
     * @return HTTP status code
     */
    public int getCode() {
        return code;
    }

    /**
     * Get the HTTP response headers.
     *
     * @return A map of list of string
     */
    public Map<String, List<String>> getResponseHeaders() {
        return responseHeaders;
    }

    /**
     * Get the HTTP response body.
     *
     * @return Response body in the form of string
     */
    public String getResponseBody() {
        return responseBody;
    }
}
